/*    1D signal processing. Project 1  CSE 232 Fall 2006

      begun 27 Aug 2006 by GCS; 

      This program performs these major commands:

      read  <filename>  clear out all other stored information
                        relating to the former signal and read in
                        a new signal making it the current signal

      write <filename>  write the current signal to the output file   

      crop

      interpolate

      fitLine

      fitQuadratic

      zmean             make the current signal have zero mean

      plot              show a plot of the current signal data

      exit              terminate the program

      slide

      slope

      threshold

*/

using namespace std;
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include "/Users/Josh/Programs/cpp/cse232/Project1A/signal.h"  


int main()
{
  string command, commentLine, filename;
  // char fileName[80];
  double Current[maxSize], SavedSignal[maxSize]; 
  int currentSize, savedSize;
  double currentMin, currentMax, currentEnergy, currentMean;

  bool DEBUG = 0;   // flag for intemediate output

  bool HAVE_SIGNAL = 0;
  
  fstream InFile, OutFile;

  cout << "\n---+--- Project 1 V1: 27 Aug 2006 Stockman  ---+---\n";
 
  cout << "\ncommand> ";  
  cin >> command;
  
  while (command != "exit")
    {
      cout << "\ncommand= " << command << endl;
      
      if (command == "read") {            //  ========  read   

	cin >> filename;
	cout << endl << "input a signal from file = " << filename;
	if ( readSignal(filename, Current, maxSize, currentSize) )
             {
		cout << "\nSignal file loaded successfully: "
                     << currentSize << " amplitude values." << endl;
		HAVE_SIGNAL = 1;
	     } 
        else cout << "\n<*> Signal not read correctly.<*> \n"; 
      }

      else if (command == "comment") {    //  ========== comment 
        getline(cin, commentLine);
        cout << "\n*-* COMMENT *-* " << commentLine << endl;
      }
      
      else if (command == "crop") {        //  ========== crop
	cout << command << " <*> not yet implemented <*>\n";
	getline(cin, commentLine);
      }
          
      else if (command == "plot") {       //  ======== plot  

	getStats (Current, currentSize, 0, currentSize-1, currentMin, currentMax,
		currentEnergy, currentMean);
	cout << "\n Signal has " << currentSize << " amplitudes: " 
		<< " min= " << currentMin << " max= " << currentMax << endl;
	cout << " Mean Value = " << currentMean << " energy = " << currentEnergy;

	printPlot ( Current, currentSize, 0, currentSize-1, currentMin, currentMax );
      }

      else if (command == "threshold") {   //  ========  threshold 
	cout << command << " <*> not yet implemented <*>\n";
	getline(cin, commentLine);
      }

      else if (command == "zeromean") {   //  =========  zeromean
	cout << command << " <*> not yet implemented <*>\n";
	getline(cin, commentLine);
      }
      //    ===================  command not recognized

      else cout << endl << "<*> " << command << " <*> not recognized\n";

      //    ===================  prompt for new command

      cout << "\ncommand> "; 
      cin >> command;    //  read the next command

    }   //  end while loop reading commands

  return 0;
  }; // end main 
 
