//  
//  CSE 232 Project1A   first draft of project 1  
//
//  Performs several tests of signal operations: version 1 27 Aug 06
//
//  By GCS for CSE 232 Fall 2006   

using namespace std;
#include <iostream>
#include <string>
#include "/Users/Josh/Programs/cpp/cse232/Project1A/signal.h" 
#include <fstream>
#include <iomanip> 

/*  ------------------------------------------------------------

    plotPoint   is used for plotting a single value on a given
                range [min, max],  such as "   *	"

                No value is returned; all effects are side affects
		-- output to cout.
		
    Ncells      is the number of characters of width for the range
                typically 50 char of width

    amp         is the value to be plotted

    min, max    is the range containing amp
*/


void plotPoint ( double amp, int Ncells, double min, double max )
{
   //  compute the position of the '*' in the line of size Ncells
   int Position = int (Ncells *  (amp - min) / (max - min) );
   for ( int j=0; j<Position; j++ )  cout << ' ';
   cout << '*';   // place star in correct position
   cout << endl;
}

/*  ------------------------------------------------------------

    printPlot     plots an entire signal, one print line per amplitude

                  No value is returned, output is to cout

    ampValues[]   contains size amplitudes

    LO, HI        give subsequence of amplitudes to print

    Smin, Smax    are min and max of the amplitudes

*/

void printPlot ( const double ampValues[], int size, int LO, int HI,
		 double Smin, double Smax )
{
  assert( (size>0) && (0 <= LO) && (LO <=HI) && (HI<size) ); 

  cout << endl << endl;
  for(int k=0; k<8; k++)  cout << "-.-.-.-.-.-" ;

  cout << endl << "PLOT OF SIGNAL: "  << HI-LO+1 
       << " amplitudes." << endl << endl;
  cout << setiosflags(ios::showpoint | ios::fixed | ios::right)
       << setprecision(3) ;
  cout << "         x      y=s(x) " << endl << endl;

  for(int i=LO; i<=HI; i++) 
     {
       cout << setw(10) << i << "  " << setw(10) << ampValues[i] << "  ";
       plotPoint ( ampValues[i], 50,  Smin, Smax );
       // cout << endl;
     };
  for( int k=0; k<8; k++)  cout << "-.-.-.-.-.-" ;
  cout << endl << endl;
}  // end of printPlot


/*  ----------------------------------------------------------

    getStats        computes and returns signal statistics

*/
void getStats(const double ampValues[], const int signalSize, 
	const int lo, const int hi,   // first 4 are in-only
	double& min, double& max,
	double& energy, double& mean) // last 4 are out-only

{
	//  check for legal window later
  energy = 0.0;    mean = 0.0;    min = ampValues[0];  max = ampValues[0];

  //  need some computation here
}

bool readSignal ( const string& fileName, double signal[], int maxSize, int& actualSize)

  {
    ifstream InFile;
    InFile.open( fileName.c_str() );
    if ( !InFile )
      {
        cerr << "***** Unable to open input file " << fileName << "\n";
        return 0;
      }

	  actualSize = 0;
	  InFile >> signal[actualSize];

 	  while (!InFile.eof())
		{
		  actualSize++;
		  InFile >> signal[actualSize];
		} 
          InFile.close();
          return 1;

	};  // end readSignal 


